<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <title>CS 1653 Project P3 Writeup</title>
  <style>
/* BEGIN CHANGES HERE */

/* In this section, you may add CSS styling if desired.
 * Be sure your writeup still prints legibly. */
header {
  text-align: center;
}

body {
  margin: 40px auto;
  max-width: 61.8034%;
  line-height: 1.6;
  font-size: 18px;
  color: #444;
  padding: 0 10px;
}

/* END CHANGES HERE */
  </style>
  <body>
    <header>
      <h1>CS 1653 Project P3 Writeup</h1>
      <h2>
<!-- BEGIN CHANGES HERE -->

      <p>Christopher Constantino</p>
      <p>Jordon Rapoport</p>
      <p>Michael Stoltz</p>

<!-- END CHANGES HERE -->
      </h2>
    </header>
    <section id="overview">
      <h2>Overview</h2>
<!-- BEGIN CHANGES HERE -->
<p>In our system, there are four principals:</p>

<ol>
<li>Any number of users who interface with the system via a client. Upon the
initialization of the user (i.e. the creation of the user's account by the
administrator), any particular user is assumed to know three things:
<ul>
<li>His username (public).</li>
<li>His password (secret).</li>
<li>The public keys of the file servers he trusts (public).</li>
</ul></li>
<li>A group server, which upon initialization (i.e. being set up locally by the
administrator) knows the following:
<ul>
<li>Its RSA key pair.</li>
<li>The UserList object, which contains the list of users, the list of
groups, and the user-to-group membership relation.</li>
<li>A list of <var>(username, salt, verifier)</var> tuples, with one per
known user.</li>
</ul>
<li>Any number of file servers, each of which upon initialization know the
following:
<ul>
<li>This file server's RSA key pair.</li>
<li>The group server's public key.</li>
</ul></li>
<li>Any number of intruders, attackers, adversaries, what-have-you. Each
adversary is assumed to know the following at all times:
<ul>
<li>The contents of every message transmitted over the network, which
consists of the following connections:
<ul>
<li>User to group server.</li>
<li>User to file server.</li>
<li>User to impostor group server.</li>
<li>User to impostor file server.</li>
<li>Impostor to group server.</li>
<li>Impostor to file server.</li>
</ul></li>
<li>The address of the group server.</li>
<li>The address of every file server.</li>
</ul></li>
</ol>

<p>Additionally, there are four threats enumerated below, which are addressed
through the use of the following algorithms:</p>

<ul>
<li><b>RSA</b> with 2048-bit keys for guaranteeing the authenticity of tokens
and for establishing symmetric encryption between users and file servers.</li>
<li><b>SHA-256</b>, also for guaranteeing the authenticity of tokens, as well
as for hashing passwords.</li>
<li><b>AES</b> with either 128 or 256-bit keys and OFB mode for encrypting
communications subsequent to authentication.</li>
<li><b>SRP-6a</b> for mutually authenticating users with the group server
as well as for sharing a secret which is used to create session keys for
encrypting communications.</li>
</ul>

<p>In order for the system to operate as described, there are several "static"
components which are expected to be initialized "out of band." These are as
follows:</p>

<ul>
<li>The group server's key pair must be generated and its public key
distributed to each of the file servers for verification purposes. The
generation of the key pair is simple, as our implementation will include a
program called KeyGen which is capable of generating RSA key pairs. The public
key can, for example, be posted online or sent via email by the administrator
of the group server to the administrator(s) of the file server(s).</li>
<li>The file servers' keys must be generated and their public keys distributed.
The generation process is identical to that of the group server, but the
distribution process is slightly different. Users never need to store the file
server keys on their client computers, although they are expected to recognize
whether a given public key (or rather, the SHA-256 fingerprint of the key) is
that belonging to a legitimate file server. Because these fingerprints are
public, they can also be distributed over public channels. For example, the
administrator of the group server (who has complete control over the entire
system, effectively) can be tasked with curating file servers (i.e. keeping
track of which ones are legitimate) and posting a list of key fingerprints
online or on a mailing list to all users in his particular group network.</li>
</ul>

<!-- END CHANGES HERE -->
    </section>
    <section id="threat1">
      <h2>Threat T1: Unauthorized Token Issuance</h2>
<!-- BEGIN CHANGES HERE -->
<p>Tokens are used to prove to the group and file servers that the requester of
an action has the necessary permissions to do so. To the file servers, it is
the only means that a user may authenticate himself. Because of this, acquiring
another user's token allows one to impersonate that user and request actions be
performed on his behalf.</p>

<p>In order to protect against illegitimate clients requesting tokens from
the group server, each legitimate user has a datum known to the group server.
Because the group server must know this datum and must also have a secure,
authenticated connection in order to transmit it (i.e. to create a new
user), the process must be bootstrapped by the offline configuration of the
administrator. On the initial run of the group server, the administrator enters
his username and password for it to store. This allows the administrator to
establish a secure connection, over which new users and their passwords can be
sent, allowing the group server to store whatever data it needs for those users
to have secure connections as well.</p>

<p>For that connection to be "secure" as described above, it must mitigate
threat 4, which requires ensuring that a passive adversary monitoring the
connection between the two is unable to gain access to any secret which
would elevate his access permissions, e.g. by allowing the impersonation of
another user. Furthermore, to handle threat 1, we must ensure that the user
authenticates himself to the group server, and that either (a) the group server
authenticates its identity to the user or (b) the user transmits no secret
information to an adversary posing as the group server.</p>

<p>The SRP protocol both of these threats, namely:</p>

<ul>
<li>Knowledge of the user's password is required to derive the secret value
<var>H(salt, username, password)</var>. If we assume that only legitimate users know their
corresponding (username, password) pairs, then a user's ability to enter his at
the client side is sufficient to prove his identity to the group server.</li>
<li>A passive adversary who intercepts the messages in the SRP protocol comes
no closer to finding this weak secret, because the values being transmitted
either require infeasible computational resources or access to information
only known locally to the legitimate principals in the exchange (i.e.
randomly-generated halves of a shared secret that are exchanged to create a
whole shared secret)</li>
<li>By sending an optional 6th message (in the SRP-6a version specifically;
other versions of the protocol exchange messages differently), the group server
is able to prove its identity to the user (after the user has already proved
his identity).</li>
</ul>

Furthermore, there are a number of threats that SRP protects against which are
not in our threat model. The first protocol that came under our consideration
was EKE, but we quickly abandoned it due to its vulnerability to offline
attacks; if an attacker were to gain access to <tt>UserList.bin</tt>, he would
be able to impersonate any user. SRP solves this problem by only requiring
the storage of a salt value (which is completely public, and in fact is
transmitted in the clear when performing the SRP exchange) and a complementary
value computed from the hash of the user's username, password, and salt
using a predetermined generator and modulus. In addition to being secure
against active offline attacks (i.e. when the attacker has local access to
<tt>UserList.bin</tt>), it is secure against active online attacks such as the
manipulation of messages in transit (which can cause the authentication to
fail, but not otherwise undermining any of SRP's guarantees of authenticity and
security). Online guessing attacks are limited to one guess per exchange, and
time restrictions could be fairly easily implemented against an attacker who
attempts to guess passwords in bulk.

<p>The following figure contains the message diagram for SRP-6a, which our
system will use. In it,</p>
<ul>
  <li>
    <var>N</var> is a large safe prime and <var>g</var> is a generator modulo
    <var>N</var>
  </li>
  <li>All values are computed modulo <var>N</var></li>
  <li>
    <var>x</var> = <var>H(salt, username, password)</var>
  </li>
  <li>
    <var>v</var> = <var>g</var><sup><var>x</var></sup>,
    referred to above as <var>verifier</var>
  </li>
  <li><var>I</var> = <var>username</var></li>
  <li><var>s</var> = <var>salt</var></li>
  <li><var>P</var> = the user's password</li>
  <li>
    <var>A</var>, <var>B</var> are halves of a shared secret,
    different with each exchange
  </li>
  <li><var>S</var> is the shared secret</li>
  <li>
    <var>K</var> is the final "key" value, although our system will use the
    SHA-256 hash of this "key" as an appropriately-sized key for AES
  </li>
  <li><var>M1</var> and <var>M2</var> are the challenge values used to prove identity</li>
  <li><var>a</var>, <var>b</var>, and <var>u</var> are randomly generated values</li>
</ul>

<figure>
<img src="img/SRP-6.png">
</figure>
<cite>SRP-6: Improvements and Refinements to the Secure
Remote Password Protocol, Thomas Wu, 2002.</cite>

<p>Our implementation will differ only in that the last message will also
contain an IV for the cipher.</p>

<p>As shown above, SRP allows for the sharing of a secret between two
principals who have access to either a secret piece of information or something
derived from it. From that shared secret, a secret symmetric key can be easily
derived by both principals, enabling encryption and decryption of any data
transmitted after the point of the SRP exchange. In our system specifically,
this implies that the user's token can be transmitted in encrypted form over
the network. For more information on how the authenticity of the token is
guaranteed at later points, see Threat 2.</p>

<!-- END CHANGES HERE -->
    </section>
    <section id="threat2">
      <h2>Threat T2: Token Modification/Forgery</h2>
<!-- BEGIN CHANGES HERE -->
<p>In our current trust model, the users or clients are not trusted by either the
group or the file servers. There are a number of threats malicious users are
expected to attempt to exploit. One of these threats is token modification and
forgery. The token is essential to our file sharing application. It is the only
way information about the user is received by the file servers. If users were
to manually change their tokens, they could edit the groups they have access
to. One of these groups could even be the ADMIN group, giving the user access
to many actions they should not have.</p>

<p>To protect against this threat, our protocol utilizes public key cryptography.
The token will be extended to have an additional field. All contents of the
token which are to be protected from forgery (namely, the issuer, subject, and
subject's groups) will be aggregated in a canonical fashion and hashed using
the SHA-256 algorithm. Then, the hash will be signed using the group server's
private key and stored in the token. At any time where an operation on either
server depends on a property of one of the token's fields, the server will
recompute the hash of the token and compare it to the hash signed with the
group server's private key.</p>

<p>Note that there are a number of potential issues with generating a canonical
string representation of the token. To protect against these problems, the
following algorithm shall be used to ensure a unique canonical representation:</p>

<figure>
<p>Input: A token consisting of an <var>issuer</var>, a <var>subject</var>,
and a list of <var>groups</var>.</p>

<ol>
<li>Obtain a byte representation of <var>issuer</var>, <var>subject</var>, and
<var>groups</var> by encoding them in UTF-8.</li>
<li>Join the strings together with the delimiter 0xF4F4F4F4 (an invalid byte
sequence in UTF-8), with <var>issuer</var> first, <var>subject</var> second, and
each string in <var>groups</var>, sorted lexicographically as byte strings, with
duplicates removed.</li>
<li>Take the SHA-256 hash of the resulting string of bytes.</li>
</ol>
</figure>

<p>This solution will allow us to make sure users have not modified their
tokens in any way before going through with any actions they attempt to
execute. Since the hash of the original token is signed by the group server's
private key, there is no way for the client to re-sign the token after
modifying it since the client will not have access to the group server's
private key. We assume that the manual distribution of the group server's
public key to the file servers in the initialization process will be correct.
These servers will then use the public key to check the token's signature
against it and make sure it has not been modified.</p>
<!-- END CHANGES HERE -->
    </section>
    <section id="threat3">
      <h2>Threat T3: Unauthorized File Servers</h2>
<!-- BEGIN CHANGES HERE -->
<p>Because the group server is not permitted to maintain a list of trusted
file servers, the burden rests on the users (who may look out-of-band to some
trusted authority for whether a particular public key should be accepted as
legitimate). File servers are uniquely identified by their public keys, which
are generated at initialization. The user initiates communication with a file
server. The file server responds by sending its public key and an IV to the
user. If the key is not among the client's known trusted keys, the user is
prompted with whether he trusts that particular key. If the user answers in
the negative, the connection is terminated. (In this regard, our protocol
behaves similarly to SSH.) Otherwise, he generates a symmetric AES key for this
session, encrypts it with the file server's public key, and sends it. The IV
serves as a nonce value that prevents the replaying of messages one and two by
a passive adversary, thus rendering each request only valid in this session.
The protocol is illustrated in the diagram below:</p>

<figure>
<img src="img/user_fs.png">
<figcaption>Protocol for connecting to file server</figcaption>
</figure>

<p>Unfortunately, this is not a strong guarantee that users will only access
legitimate file servers. The reality is that whether a file server is
legitimate or not depends on a trusted authority, such as the administrator who
configures the system to begin with.</p>

<p>In addition to that, it is also vulnerable to a man-in-the-middle attack.
An active attacker could wait for the session to be established and for the
user to send, for example, a request to download a file. The attacker could
then hijack the session and replay that request, allowing him to download the
file. Being an active form of attack, this is not something we are required to
prevent under the current threat model. However, we acknowledge that in future
threat models it poses an issue.</p>
<!-- END CHANGES HERE -->
    </section>
    <section id="threat4">
      <h2>Threat T4: Information Leakage via Passive Monitoring</h2>
<!-- BEGIN CHANGES HERE -->
<p>As stated earlier, in our threat model we assume the existence of a passive
adversary who monitors all communications sent over the network. The only
messages sent in cleartext at any point are as follows the user's username when
initiating communication with the group server, and some arbitrary value when
initiating communication with a file server.</p>

<p>After the operations described under Threat 3, a secure connection between the
user and the file server will have been established. This allows the user to
transmit messages containing sensitive information — namely, his token,
the actions he wishes the server to perform, and any files he wishes to upload.
The file server will also use this key to encrypt any files being downloaded.
Likewise, the protocol described under Threat 1 for a user connecting to a
group server allows for the establishment of encrypted communications in
addition to mutual authentication.</p>
<!-- END CHANGES HERE -->
    </section>
    <section id="discussion">
      <h2>Discussion</h2>
<!-- BEGIN CHANGES HERE -->

<p>We knew we needed to use a strong password protocol for authenticating
users. Originally the idea of EKE was discussed in detail, but we felt that
a stronger protocol that protects against offline attacks would be a better
route to help prepare for possible future threat models. SRP was picked as our
authentication solution. It gives us the authentication and acquires a secure
connection while forcing an adversary to do a dictionary attack. The necessity
of a secure connection also being established was important to help with T4. As
Bill mentioned to us in our discussion, since SRP protects against additional
threats not necessarily in this threat model, we hope it will be considered for
extra credit.</p>

<p>For checking the integrity of the token, signing using public key crypto
only seemed logical. Because we are able to manually put the group server's
public key on the file server during setup, it solves the issue of the
group and file servers not communicating and preventing the public key from
originally getting transferred. With the public key in hand, the file server
can easily check the signature of the token and make sure it has not been
modified.</p>

<p>After exploring how SSH authenticates users, we decided to take a similar
approach. The file servers can all have a public/private key pair. The user
can then have a list of trusted public key pairs, when the connection is
established the file server sends its public key, if the key is not in the list
of trusted keys, the user is simply prompted to ask if they trust it, and if so
it is added. To help finish solving T4, we realized a symmetric key protocol
made sense for the communication between the user and the file server. To make
sure the file server is who it claims to be, and to safely distribute this
session's symmetric key, it is encrypted using the file server's public key and
sent to it, so only that file server will be able to decrypt it and establish
the secure connection to the user.</p>
<!-- END CHANGES HERE -->
    </section>
  </body>
</html>

